#include "devGTK.h"
#include <R_ext/Rdynload.h>

#ifdef USE_R_PTR
extern DL_FUNC ptr_GTKDeviceDriver, stub_GTKDeviceDriver;
#endif

/**
  Ensure that gtk is loaded. We may want to leave this to 
  another package, e.g.  RGtk, so that people can add their own 
  options.
 */
void loadGTK()
{
    char **argv; 
    int argc = 1;
    argv = (char **) g_malloc(argc * sizeof(char *));
    argv[0] = g_strdup("R");
    gtk_init(&argc, &argv);
#ifdef USE_R_PTR
    ptr_GTKDeviceDriver = GTKDeviceDriver;
#endif
}

#ifdef USE_R_PTR
/* 
 This is not needed as we do everything locally with a new version
 of the gtk() function that works entirely within the C routines, etc.
 of this package.
 */
void unloadGTK()
{
    ptr_GTKDeviceDriver = R_FindSymbol("stub_GTKDeviceDriver", "", NULL);
}
#endif


